#!/usr/local/bin/itkwish3.0
# browse --
# This script generates a directory browser, which lists the working
# directory and allows you to open files or subdirectories by
# double-clicking.
#
# @(#) browse 1.5 95/05/26 16:20:51

# Create a scrollbar on the right side of the main window and a listbox
# on the left side.
# this checks to see if we are running under Linux, if not it assumes windows 95/98.
# this won't run under Macintosh.

if {$tcl_platform(os) == "Linux"} {
cd ~
set rootdirectory [pwd]

} else {
set rootdirectory C:/Progra~1/tcl/bin
cd $rootdirectory/drug_programs

source comm.tcl

}

cd $rootdirectory/drug_programs
option readfile ./tkoptions
source balloonhelp.tcl

# these two procedures are for merging or renaming files.
proc loadFileEdit {file window} {
     $window delete 1.0 end
     set lineno 1
     set f [open $file]
     while {![eof $f]} {
     $window insert end [gets $f]\n
     $window yview end
     }
   close $f
}

proc writeFileEdit {file window} {
     set f [$window get 1.0 end]
     set f2 [open $file w]
     puts $f2 $f
     close $f2
     
}

# this checks to see if there is a file for the synonym drug when called from the right click
# editor box on the drug name. If there isn't, one is created and the list is refreshed.
proc addFiles { oldname } {
global rootdirectory
global tcl_platform
 set f [open $oldname r]
 while {![eof $f]} {
    gets $f line
    if {![file isfile $line] && $line != ""} {
        set g [open $line w]
        puts $g $oldname
        close $g

        }
    if {![file isfile $rootdirectory/drug_interactions/$line] && $line != ""} {
       if {$tcl_platform(os) == "Linux"} {
       exec cp $rootdirectory/drug_interactions/$oldname $rootdirectory/drug_interactions/$line
       } else {
               exec command.com /c copy $rootdirectory/drug_interactions/$oldname $rootdirectory/drug_interactions/$line
              }
       }
    if {![file isfile $rootdirectory/drug_doses/$line] && $line != ""} {
       if {$tcl_platform(os) == "Linux"} {
       exec cp $rootdirectory/drug_doses/$oldname $rootdirectory/drug_doses/$line
       } else {
              exec command.com /c copy $rootdirectory/drug_doses/$oldname $rootdirectory/drug_doses/$line
              }
       }

    }
close $f
.list delete 0 end;refresh

}

#This procedure is to delete all the files associated with a drug.

proc deleteName { nametobedeleted } {

global rootdirectory
global tcl_platform
if {$tcl_platform(os) == "Linux"} {
exec rm -f $rootdirectory/drugs/$nametobedeleted &
exec rm -f $rootdirectory/drug_doses/$nametobedeleted &
exec rm -f $rootdirectory/drug_interactions/$nametobedeleted &
exec rm -f $rootdirectory/drug_information/${nametobedeleted}.cfm &
} else {
exec command.com /c del $rootdirectory/drugs/$nametobedeleted
exec command.com /c del $rootdirectory/drug_doses/$nametobedeleted
exec command.com /c del $rootdirectory/drug_interactions/$nametobedeleted
exec command.com /c del $rootdirectory/drug_information/${nametobedeleted}.cfm
}
.list delete 0 end;refresh

}

# This procedure is used to move a drug's files to new files under a different name. Used
# when you accidently enter the wrong spelling for the drug and you want to change all the
# files to the correct spelling.

proc mergeName { oldname newname } {

global rootdirectory
global tcl_platform
if {$tcl_platform(os) == "Linux"} {
exec mv $rootdirectory/drugs/$oldname $rootdirectory/drugs/$newname &
exec mv $rootdirectory/drug_doses/$oldname $rootdirectory/drug_doses/$newname &
exec mv $rootdirectory/drug_interactions/$oldname $rootdirectory/drug_interactions/$newname &
exec mv $rootdirectory/drug_information/${oldname}.cfm $rootdirectory/drug_interactions/${newname}.cfm &
} else { 
exec command.com /c move $rootdirectory/drugs/$oldname $rootdirectory/drugs/$newname 
exec command.com /c move $rootdirectory/drug_doses/$oldname $rootdirectory/drug_doses/$newname 
exec command.com /c move $rootdirectory/drug_interactions/$oldname $rootdirectory/drug_interactions/$newname &
exec command.com /c move $rootdirectory/drug_information/${oldname}.cfm $rootdirectory/drug_interactions/${newname}.cfm &
}
.list delete 0 end;refresh

}

global nameentry
set nameentry ".topframe.topleftframe.topleftleftframe.nameentry"
cd $rootdirectory/drugs
entry .entry -textvariable namefragment
balloonhelp .entry "Enter part of the drug
name here and press 
RETURN to search for
a drug."
button .refresh -text Refresh -height 1 -bg orange -fg brown -command {.list delete 0 end;refresh}
pack .refresh
balloonhelp .refresh "Press this to refresh
the drug names if any
new ones have been added."
pack .entry -side top -fill x -expand true
scrollbar .scroll -command ".list yview"
pack .scroll -side right -fill y
listbox .list  -yscroll ".scroll set" -relief sunken \
-width 20 -height 20 \
	-setgrid yes 
pack .list -side left -fill both -expand yes
balloonhelp .list "Double left click
scans for the selected drug in 
the currently selected patient's
drug refill file. If found, the drugstore,
dose and quantity of the last refill
for that drug will be loaded into the 
appropriate entry boxes in the drug 
refill program GUI.  If not found, the 
medicine name will be inserted in the 
medicine entry box and you then have to 
use the menu buttons to select the dose, 
drugstore, doctor, employee name and 
message to send."

wm minsize . 1 1
wm geometry . +0+410

proc setselection {namefragment} {
global argc tcl_platform
if $argc>0 {set dir [lindex $argv 0]} else {set dir "."}
.list see 0
set index 0
if {$tcl_platform(os) == "Linux"} {
foreach i [exec ls -a $dir] {
    .list yview $index
    if [regexp $namefragment $i] {
    .list selection set $index
    .list activate $index
    break
   };# end of if
   incr index
};# end of foreach
} else {
foreach i [exec command.com /c dir /ON $dir] {
   if {$i == "free"} {continue} else  {  
   if {$i == "bytes"} {continue} else {
   if {$i == "in"} {continue} else {
   if {$i == "drive"} {continue} else {    
   if {$i == "is"} {continue} else {    
   if {$i == "of"} {continue} else {
   if {$i == "return"} {continue} else {
   if {$i == "to"} {continue} else {
   if {$i == "has"} {continue} else {
   if {$i == "no"} {continue} else {
   if {$i == "label"} {continue} else {
   


    
     if [regexp $namefragment $i] {
        

        .list selection set $index
        .list activate $index
        focus .list
        .list yview $index
        update idletasks
        break
        }

      if [regexp {^[a-z]+$|^[a-z]+\_[a-z]+.+$} $i ]   { incr index }
     
    }
 }
 }
 }
 }
 }
 }
 }
 }
 }
 }
 }
};# end of else
};# end of proc refresh

# The procedure below is invoked to open a browser on a given file;  if the
# file is a directory then another instance of this program is invoked; if
# the file is a regular file then the Mx editor is invoked to display
# the file.

proc browselinux {dir file} {
    global env
    global name
    global nameentry
    global rootdirectory
    if {[string compare $dir "."] != 0} {set file $dir/$file}
    if [file isdirectory $file] {
	exec browse $file &
    } else {
	if [file isfile $file] {
	    if [info exists env(EDITOR)] {
		eval exec $env(EDITOR) $file &
	    } else {
                
                set medicine $file 
             
                send TFP_drugrefill.tcl "set medicine $file" 
                send TFP_drugrefill.tcl {set dose ""}
                send TFP_drugrefill.tcl {set quantity ""}
                
                send TFP_drugrefill.tcl "tgrep $file $rootdirectory/drug_refills/$name"
                send TFP_drugrefill.tcl "$nameentry configure -fg black -bg gray"
                send TFP_drugrefill.tcl {forAllMatches .text2 $medicine {.text2 tag add big first last}}
                send TFP_drugrefill.tcl ".text2 tag configure big -background peachpuff -foreground steelblue -borderwidth 2 \
                                 -font -Adobe-Helvetica-Medium-R-Normal--*-240-* -relief raised"
                 
                catch {send TFP_drugrefill.tcl ".text2 see big.last"}
       
                send TFP_drugrefill.tcl "LoadDoses"
                send TFP_drugrefill.tcl "checkdruginfo"
	    }
	} else {
	    puts stdout "\"$file\" isn't a directory or regular file"
	}
    }
}

proc browsewindows {dir file} {
    global env
    global name
    global nameentry
    global rootdirectory
    global TFP_drugrefill.tcl
    global demographicform.tcl
    global note_gen.tcl
    if {[string compare $dir "."] != 0} {set file $dir/$file}
    if [file isdirectory $file] {
	exec browse $file &
    } else {
	if [file isfile $file] {
	    if [info exists env(EDITOR)] {
		eval exec $env(EDITOR) $file &
	    } else {
                
                set medicine $file 
             
                comm send ${TFP_drugrefill.tcl} "set medicine $file" 
                comm send ${TFP_drugrefill.tcl} {set dose ""}
                comm send ${TFP_drugrefill.tcl} {set quantity ""}
                
                comm send ${TFP_drugrefill.tcl} "tgrep $file $rootdirectory/drug_refills/$name"
                comm send ${TFP_drugrefill.tcl} "$nameentry configure -fg black -bg gray"
                comm send ${TFP_drugrefill.tcl} {forAllMatches .text2 $medicine {.text2 tag add big first last}}
                comm send ${TFP_drugrefill.tcl} ".text2 tag configure big -background peachpuff -foreground steelblue -borderwidth 2 \
                                 -font -Adobe-Helvetica-Medium-R-Normal--*-240-* -relief raised"
                 
               catch {comm send ${TFP_drugrefill.tcl} ".text2 see big.last"}
       
                comm send ${TFP_drugrefill.tcl} "LoadDoses"
                comm send ${TFP_drugrefill.tcl} "checkdruginfo"
	    }
	} else {
	    puts stdout "\"$file\" isn't a directory or regular file"
	}
    }
}



# Fill the listbox with a list of all the files in the directory (run
# the "ls" command to get that information).

if $argc>0 {set dir [lindex $argv 0]} else {set dir "."}
if {$tcl_platform(os) == "Linux"} {
foreach i [exec ls -a $dir] {
    .list insert end $i
}
} else {
foreach i [exec command.com /c dir /ON $dir] {
#    puts "i = $i"
   if {$i == "free"} {continue} else  {  
   if {$i == "bytes"} {continue} else {
   if {$i == "in"} {continue} else {
   if {$i == "drive"} {continue} else {    
   if {$i == "is"} {continue} else {    
   if {$i == "of"} {continue} else {
   if {$i == "return"} {continue} else {
   if {$i == "to"} {continue} else {
   if {$i == "has"} {continue} else {
   if {$i == "no"} {continue} else {
   if {$i == "label"} {continue} else {
   if [regexp {^[a-z]+$|^[a-z]+\_[a-z]+.+$} $i ]   { .list insert end $i }

}
}
}
}
}
}
}
}
}
}
}
}


};# end of else
proc refresh { } {
global argc argv dir tcl_platform
if $argc>0 {set dir [lindex $argv 0]} else {set dir "."}
if {$tcl_platform(os) == "Linux"} {
foreach i [exec ls -a $dir] {
    .list insert end $i
};# end of foreach
} else {
foreach i [exec command.com /c dir /ON $dir] {
#    puts "i = $i"
   if {$i == "free"} {continue} else  {  
   if {$i == "bytes"} {continue} else {
   if {$i == "in"} {continue} else {
   if {$i == "drive"} {continue} else {    
   if {$i == "is"} {continue} else {    
   if {$i == "of"} {continue} else {
   if {$i == "return"} {continue} else {
   if {$i == "to"} {continue} else {
   if {$i == "has"} {continue} else {
   if {$i == "no"} {continue} else {
   if {$i == "label"} {continue} else {
   if [regexp {^[a-z]+$|^[a-z]+\_[a-z]+.+$} $i ]   { .list insert end $i }
}
}
}
}
}
}
}
}
}
}
}
}

};# end of else
};# end of proc refresh

# Set up bindings for the browser.

bind all <Control-c> {destroy .}
if {$tcl_platform(os) == "Linux"} {
bind .list <Double-Button-1> {foreach i [selection get] {browselinux $dir $i}}
} else {
bind .list <Double-Button-1> {foreach i [selection get] {browsewindows $dir $i}}
}
bind .list <Button-3> {foreach i [selection get] {
         toplevel .allergy ;text .allergy.text -wrap word -yscrollcommand ".allergy.scroll set"
        ;pack .allergy.text -side left -expand true -fill both;
        scrollbar .allergy.scroll -command ".allergy.text yview"
        ;wm title .allergy "$i - synonyms"
        ;pack .allergy.scroll -side left -fill y;loadFileEdit  $i .allergy.text
        ;button .allergy.save -command {writeFileEdit $i .allergy.text;addFiles $i;bell} -text Save
        ;pack .allergy.save -side bottom -fill x
         ;button .allergy.delete -bg red -fg yellow -text "Del. File" -command {toplevel .allergysure
         ;label .allergysure.question -text "Sure?"
         ;button .allergysure.yes  -command "file delete $i ;destroy .allergysure;destroy .t;bell" -text Yes;
         ;button .allergysure.no -command "destroy .allergysure" -text No;pack .allergysure.question .allergysure.yes .allergysure.no};
         pack .allergy.delete -side bottom -anchor sw -fill x; button .allergy.exit -fg red -bg yellow -text Exit -command {destroy .allergy;bell};
         pack .allergy.exit -side top -fill x } 
         }

bind .entry <Key-Return> {setselection $namefragment}

bind .list <Button-2> {foreach i [selection get] {
                              toplevel .del_merge
                              entry .del_merge.oldname -textvariable oldname
                              pack .del_merge.oldname
                              entry .del_merge.newname -textvariable newname
                              pack .del_merge.newname
                              button .del_merge.delete -text {Delete All Drug's Files} \
                              -command {deleteName $oldname;toplevel .informuser;label .informuser.inform -text {destroying $oldname};pack .informuser.inform;after 5000;destroy .informuser;destroy .del_merge}
                              pack .del_merge.delete
                              button .del_merge.merge -text {Move Drug's Files to New Name} \
                              -command {mergeName $oldname $newname;toplevel .informuser;label .informuser.inform -text {moving $oldname to $newname ...};pack .informuser.inform;after 5000;destroy .informuser;destroy .del_merge}
                              pack .del_merge.merge }
                             }

if {$tcl_platform(os) != "Linux"} {
tk appname "browsedrug.tcl [comm self]"
wm title . "browsedrug.tcl [comm self]"
exec wish80 c:/progra~1/tcl/bin/drug_programs/TFP_drugrefill.tcl &
}

proc returnappname {} {
return [tk appname]
}
